Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ boot/Makefile.common	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -166,4 +166,5 @@
 	$(USPACE_PATH)/app/lsusb/lsusb \
 	$(USPACE_PATH)/app/sbi/sbi \
+	$(USPACE_PATH)/app/sportdmp/sportdmp \
 	$(USPACE_PATH)/app/redir/redir \
 	$(USPACE_PATH)/app/taskdump/taskdump \
Index: kernel/arch/arm32/src/ras.c
===================================================================
--- kernel/arch/arm32/src/ras.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ kernel/arch/arm32/src/ras.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -86,2 +86,4 @@
 }
 
+/** @}
+ */
Index: kernel/generic/include/adt/list.h
===================================================================
--- kernel/generic/include/adt/list.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ kernel/generic/include/adt/list.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -173,5 +173,5 @@
  *
  */
-NO_TRACE static inline int list_empty(list_t *list)
+NO_TRACE static inline int list_empty(const list_t *list)
 {
 	return (list->head.next == &list->head);
@@ -186,5 +186,5 @@
  *
  */
-static inline link_t *list_first(list_t *list)
+static inline link_t *list_first(const list_t *list)
 {
 	return ((list->head.next == &list->head) ? NULL : list->head.next);
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -51,4 +51,5 @@
 	app/redir \
 	app/sbi \
+	app/sportdmp \
 	app/stats \
 	app/taskdump \
Index: uspace/app/sportdmp/Makefile
===================================================================
--- uspace/app/sportdmp/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/app/sportdmp/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,37 @@
+#
+# Copyright (c) 2011 Martin Sucha
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+#LIBS = 
+#EXTRA_CFLAGS = 
+BINARY = sportdmp
+
+SOURCES = \
+	sportdmp.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/sportdmp/sportdmp.c
===================================================================
--- uspace/app/sportdmp/sportdmp.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
+++ uspace/app/sportdmp/sportdmp.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -0,0 +1,113 @@
+/*
+ * Copyright (c) 2011 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <stdio.h>
+#include <devman.h>
+#include <ipc/devman.h>
+#include <device/char_dev.h>
+#include <ipc/serial_ctl.h>
+
+#define BUF_SIZE 1
+
+static void syntax_print() {
+	fprintf(stderr, "Usage: sportdmp <baud> <device_path>\n");
+}
+
+int main(int argc, char **argv)
+{
+	const char* devpath = "/hw/pci0/00:01.0/com1/a";
+	sysarg_t baud = 9600;
+	
+	if (argc > 1) {
+		char *endptr;
+		baud = strtol(argv[1], &endptr, 10);
+		if (*endptr != '\0') {
+			fprintf(stderr, "Invalid value for baud\n");
+			syntax_print();
+			return 1;
+		}
+	}
+	
+	if (argc > 2) {
+		devpath = argv[2];
+	}
+	
+	if (argc > 3) {
+		syntax_print();
+		return 1;
+	}
+	
+	devman_handle_t device;
+	int rc = devman_fun_get_handle(devpath, &device, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		fprintf(stderr, "Cannot open device %s\n", devpath);
+		return 1;
+	}
+	
+	async_sess_t *sess = devman_device_connect(EXCHANGE_SERIALIZE, device,
+	    IPC_FLAG_BLOCKING);
+	if (!sess) {
+		fprintf(stderr, "Cannot connect device\n");
+	}
+	
+	async_exch_t *exch = async_exchange_begin(sess);
+	rc = async_req_4_0(exch, SERIAL_SET_COM_PROPS, baud,
+	    SERIAL_NO_PARITY, 8, 1);
+	async_exchange_end(exch);
+	
+	if (rc != EOK) {
+		fprintf(stderr, "Cannot set serial properties\n");
+		return 2;
+	}
+	
+	uint8_t *buf = (uint8_t *) malloc(BUF_SIZE);
+	if (buf == NULL) {
+		fprintf(stderr, "Cannot allocate buffer\n");
+		return 3;
+	}
+	
+	while (true) {
+		ssize_t read = char_dev_read(sess, buf, BUF_SIZE);
+		if (read < 0) {
+			fprintf(stderr, "Failed reading from serial device\n");
+			break;
+		}
+		ssize_t i;
+		for (i = 0; i < read; i++) {
+			if ((buf[i] >= 32) && (buf[i] < 128))
+				putchar((wchar_t) buf[i]);
+			else
+				putchar('.');
+			fflush(stdout);
+		}
+	}
+	
+	free(buf);
+	return 0;
+}
Index: uspace/drv/bus/usb/ehci/hc_iface.c
===================================================================
--- uspace/drv/bus/usb/ehci/hc_iface.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ehci/hc_iface.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -145,162 +145,4 @@
 }
 
-/** Schedule interrupt out transfer.
- *
- * The callback is supposed to be called once the transfer (on the wire) is
- * complete regardless of the outcome.
- * However, the callback could be called only when this function returns
- * with success status (i.e. returns EOK).
- *
- * @param[in] fun Device function the action was invoked on.
- * @param[in] target Target pipe (address and endpoint number) specification.
- * @param[in] data Data to be sent (in USB endianess, allocated and deallocated
- *	by the caller).
- * @param[in] size Size of the @p data buffer in bytes.
- * @param[in] callback Callback to be issued once the transfer is complete.
- * @param[in] arg Pass-through argument to the callback.
- * @return Error code.
- */
-static int interrupt_out(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-	UNSUPPORTED("interrupt_out");
-
-	return ENOTSUP;
-}
-
-/** Schedule interrupt in transfer.
- *
- * The callback is supposed to be called once the transfer (on the wire) is
- * complete regardless of the outcome.
- * However, the callback could be called only when this function returns
- * with success status (i.e. returns EOK).
- *
- * @param[in] fun Device function the action was invoked on.
- * @param[in] target Target pipe (address and endpoint number) specification.
- * @param[in] data Buffer where to store the data (in USB endianess,
- *	allocated and deallocated by the caller).
- * @param[in] size Size of the @p data buffer in bytes.
- * @param[in] callback Callback to be issued once the transfer is complete.
- * @param[in] arg Pass-through argument to the callback.
- * @return Error code.
- */
-static int interrupt_in(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-	UNSUPPORTED("interrupt_in");
-
-	return ENOTSUP;
-}
-
-/** Schedule bulk out transfer.
- *
- * The callback is supposed to be called once the transfer (on the wire) is
- * complete regardless of the outcome.
- * However, the callback could be called only when this function returns
- * with success status (i.e. returns EOK).
- *
- * @param[in] fun Device function the action was invoked on.
- * @param[in] target Target pipe (address and endpoint number) specification.
- * @param[in] data Data to be sent (in USB endianess, allocated and deallocated
- *	by the caller).
- * @param[in] size Size of the @p data buffer in bytes.
- * @param[in] callback Callback to be issued once the transfer is complete.
- * @param[in] arg Pass-through argument to the callback.
- * @return Error code.
- */
-static int bulk_out(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-	UNSUPPORTED("bulk_out");
-
-	return ENOTSUP;
-}
-
-/** Schedule bulk in transfer.
- *
- * The callback is supposed to be called once the transfer (on the wire) is
- * complete regardless of the outcome.
- * However, the callback could be called only when this function returns
- * with success status (i.e. returns EOK).
- *
- * @param[in] fun Device function the action was invoked on.
- * @param[in] target Target pipe (address and endpoint number) specification.
- * @param[in] data Buffer where to store the data (in USB endianess,
- *	allocated and deallocated by the caller).
- * @param[in] size Size of the @p data buffer in bytes.
- * @param[in] callback Callback to be issued once the transfer is complete.
- * @param[in] arg Pass-through argument to the callback.
- * @return Error code.
- */
-static int bulk_in(ddf_fun_t *fun, usb_target_t target,
-    void *data, size_t size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-	UNSUPPORTED("bulk_in");
-
-	return ENOTSUP;
-}
-
-/** Schedule control write transfer.
- *
- * The callback is supposed to be called once the transfer (on the wire) is
- * complete regardless of the outcome.
- * However, the callback could be called only when this function returns
- * with success status (i.e. returns EOK).
- *
- * @param[in] fun Device function the action was invoked on.
- * @param[in] target Target pipe (address and endpoint number) specification.
- * @param[in] setup_packet Setup packet buffer (in USB endianess, allocated
- *	and deallocated by the caller).
- * @param[in] setup_packet_size Size of @p setup_packet buffer in bytes.
- * @param[in] data_buffer Data buffer (in USB endianess, allocated and
- *	deallocated by the caller).
- * @param[in] data_buffer_size Size of @p data_buffer buffer in bytes.
- * @param[in] callback Callback to be issued once the transfer is complete.
- * @param[in] arg Pass-through argument to the callback.
- * @return Error code.
- */
-static int control_write(ddf_fun_t *fun, usb_target_t target,
-    void *setup_packet, size_t setup_packet_size,
-    void *data_buffer, size_t data_buffer_size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-	UNSUPPORTED("control_write");
-
-	return ENOTSUP;
-}
-
-/** Schedule control read transfer.
- *
- * The callback is supposed to be called once the transfer (on the wire) is
- * complete regardless of the outcome.
- * However, the callback could be called only when this function returns
- * with success status (i.e. returns EOK).
- *
- * @param[in] fun Device function the action was invoked on.
- * @param[in] target Target pipe (address and endpoint number) specification.
- * @param[in] setup_packet Setup packet buffer (in USB endianess, allocated
- *	and deallocated by the caller).
- * @param[in] setup_packet_size Size of @p setup_packet buffer in bytes.
- * @param[in] data_buffer Buffer where to store the data (in USB endianess,
- *	allocated and deallocated by the caller).
- * @param[in] data_buffer_size Size of @p data_buffer buffer in bytes.
- * @param[in] callback Callback to be issued once the transfer is complete.
- * @param[in] arg Pass-through argument to the callback.
- * @return Error code.
- */
-static int control_read(ddf_fun_t *fun, usb_target_t target,
-    void *setup_packet, size_t setup_packet_size,
-    void *data_buffer, size_t data_buffer_size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-	UNSUPPORTED("control_read");
-
-	return ENOTSUP;
-}
-
 /** Host controller interface implementation for EHCI. */
 usbhc_iface_t ehci_hc_iface = {
@@ -312,13 +154,4 @@
 	.register_endpoint = register_endpoint,
 	.unregister_endpoint = unregister_endpoint,
-
-	.interrupt_out = interrupt_out,
-	.interrupt_in = interrupt_in,
-
-	.bulk_out = bulk_out,
-	.bulk_in = bulk_in,
-
-	.control_write = control_write,
-	.control_read = control_read
 };
 
Index: uspace/drv/bus/usb/ohci/Makefile
===================================================================
--- uspace/drv/bus/usb/ohci/Makefile	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/Makefile	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -44,11 +44,10 @@
 
 SOURCES = \
-	batch.c \
 	endpoint_list.c \
 	hc.c \
-	hcd_endpoint.c \
-	iface.c \
 	main.c \
 	ohci.c \
+	ohci_batch.c \
+	ohci_endpoint.c \
 	pci.c \
 	root_hub.c \
Index: uspace/drv/bus/usb/ohci/endpoint_list.c
===================================================================
--- uspace/drv/bus/usb/ohci/endpoint_list.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/endpoint_list.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -87,10 +87,9 @@
  * The endpoint is added to the end of the list and queue.
  */
-void endpoint_list_add_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep)
+void endpoint_list_add_ep(endpoint_list_t *instance, ohci_endpoint_t *ep)
 {
 	assert(instance);
-	assert(hcd_ep);
-	usb_log_debug2("Queue %s: Adding endpoint(%p).\n",
-	    instance->name, hcd_ep);
+	assert(ep);
+	usb_log_debug2("Queue %s: Adding endpoint(%p).\n", instance->name, ep);
 
 	fibril_mutex_lock(&instance->guard);
@@ -103,25 +102,25 @@
 	} else {
 		/* There are active EDs, get the last one */
-		hcd_endpoint_t *last = list_get_instance(
-		    list_last(&instance->endpoint_list), hcd_endpoint_t, link);
+		ohci_endpoint_t *last = list_get_instance(
+		    list_last(&instance->endpoint_list), ohci_endpoint_t, link);
 		last_ed = last->ed;
 	}
 	/* Keep link */
-	hcd_ep->ed->next = last_ed->next;
+	ep->ed->next = last_ed->next;
 	/* Make sure ED is written to the memory */
 	write_barrier();
 
 	/* Add ed to the hw queue */
-	ed_append_ed(last_ed, hcd_ep->ed);
+	ed_append_ed(last_ed, ep->ed);
 	/* Make sure ED is updated */
 	write_barrier();
 
 	/* Add to the sw list */
-	list_append(&hcd_ep->link, &instance->endpoint_list);
+	list_append(&ep->link, &instance->endpoint_list);
 
-	hcd_endpoint_t *first = list_get_instance(
-	    list_first(&instance->endpoint_list), hcd_endpoint_t, link);
+	ohci_endpoint_t *first = list_get_instance(
+	    list_first(&instance->endpoint_list), ohci_endpoint_t, link);
 	usb_log_debug("HCD EP(%p) added to list %s, first is %p(%p).\n",
-		hcd_ep, instance->name, first, first->ed);
+		ep, instance->name, first, first->ed);
 	if (last_ed == instance->list_head) {
 		usb_log_debug2("%s head ED(%p-0x%0" PRIx32 "): %x:%x:%x:%x.\n",
@@ -138,39 +137,38 @@
  * @param[in] endpoint Endpoint to remove.
  */
-void endpoint_list_remove_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep)
+void endpoint_list_remove_ep(endpoint_list_t *instance, ohci_endpoint_t *ep)
 {
 	assert(instance);
 	assert(instance->list_head);
-	assert(hcd_ep);
-	assert(hcd_ep->ed);
+	assert(ep);
+	assert(ep->ed);
 
 	fibril_mutex_lock(&instance->guard);
 
-	usb_log_debug2(
-	    "Queue %s: removing endpoint(%p).\n", instance->name, hcd_ep);
+	usb_log_debug2("Queue %s: removing endpoint(%p).\n", instance->name, ep);
 
 	const char *qpos = NULL;
 	ed_t *prev_ed;
 	/* Remove from the hardware queue */
-	if (list_first(&instance->endpoint_list) == &hcd_ep->link) {
+	if (list_first(&instance->endpoint_list) == &ep->link) {
 		/* I'm the first one here */
 		prev_ed = instance->list_head;
 		qpos = "FIRST";
 	} else {
-		hcd_endpoint_t *prev =
-		    list_get_instance(hcd_ep->link.prev, hcd_endpoint_t, link);
+		ohci_endpoint_t *prev =
+		    list_get_instance(ep->link.prev, ohci_endpoint_t, link);
 		prev_ed = prev->ed;
 		qpos = "NOT FIRST";
 	}
-	assert((prev_ed->next & ED_NEXT_PTR_MASK) == addr_to_phys(hcd_ep->ed));
-	prev_ed->next = hcd_ep->ed->next;
+	assert((prev_ed->next & ED_NEXT_PTR_MASK) == addr_to_phys(ep->ed));
+	prev_ed->next = ep->ed->next;
 	/* Make sure ED is updated */
 	write_barrier();
 
 	usb_log_debug("HCD EP(%p) removed (%s) from %s, next %x.\n",
-	    hcd_ep, qpos, instance->name, hcd_ep->ed->next);
+	    ep, qpos, instance->name, ep->ed->next);
 
 	/* Remove from the endpoint list */
-	list_remove(&hcd_ep->link);
+	list_remove(&ep->link);
 	fibril_mutex_unlock(&instance->guard);
 }
Index: uspace/drv/bus/usb/ohci/endpoint_list.h
===================================================================
--- uspace/drv/bus/usb/ohci/endpoint_list.h	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/endpoint_list.h	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -37,5 +37,5 @@
 #include <fibril_synch.h>
 
-#include "hcd_endpoint.h"
+#include "ohci_endpoint.h"
 #include "hw_struct/endpoint_descriptor.h"
 #include "utils/malloc32.h"
@@ -69,6 +69,6 @@
 int endpoint_list_init(endpoint_list_t *instance, const char *name);
 void endpoint_list_set_next(endpoint_list_t *instance, endpoint_list_t *next);
-void endpoint_list_add_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep);
-void endpoint_list_remove_ep(endpoint_list_t *instance, hcd_endpoint_t *hcd_ep);
+void endpoint_list_add_ep(endpoint_list_t *instance, ohci_endpoint_t *ep);
+void endpoint_list_remove_ep(endpoint_list_t *instance, ohci_endpoint_t *ep);
 #endif
 /**
Index: uspace/drv/bus/usb/ohci/hc.c
===================================================================
--- uspace/drv/bus/usb/ohci/hc.c	(revision 85ff862c8e671c25e6519e7b413df4741a121b5a)
+++ uspace/drv/bus/usb/ohci/hc.c	(revision f1d6866f8c36bca71fbb74e645c7d9c487d3ff60)
@@ -42,5 +42,5 @@
 
 #include "hc.h"
-#include "hcd_endpoint.h"
+#include "ohci_endpoint.h"
 
 #define OHCI_USED_INTERRUPTS \
@@ -61,5 +61,5 @@
 static int hc_init_memory(hc_t *instance);
 static int interrupt_emulator(hc_t *instance);
-
+static int hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
 /*----------------------------------------------------------------------------*/
 /** Get number of commands used in IRQ code.
@@ -128,5 +128,6 @@
 
 	const usb_address_t hub_address =
-	    device_keeper_get_free_address(&instance->manager, USB_SPEED_FULL);
+	    usb_device_manager_get_free_address(
+	        &instance->generic.dev_manager, USB_SPEED_FULL);
 	if (hub_address <= 0) {
 		usb_log_error("Failed to get OHCI root hub address: %s\n",
@@ -135,26 +136,29 @@
 	}
 	instance->rh.address = hub_address;
-	usb_device_keeper_bind(
-	    &instance->manager, hub_address, hub_fun->handle);
-
-#define CHECK_RET_RELEASE(ret, message...) \
+	usb_device_manager_bind(
+	    &instance->generic.dev_manager, hub_address, hub_fun->handle);
+
+#define CHECK_RET_UNREG_RETURN(ret, message...) \
 if (ret != EOK) { \
 	usb_log_error(message); \
-	hc_remove_endpoint(instance, hub_address, 0, USB_DIRECTION_BOTH); \
-	usb_device_keeper_release(&instance->manager, hub_address); \
+	usb_endpoint_manager_unregister_ep( \
+	    &instance->generic.ep_manager, hub_address, 0, USB_DIRECTION_BOTH);\
+	usb_device_manager_release( \
+	    &instance->generic.dev_manager, hub_address); \
 	return ret; \
 } else (void)0
-
-	int ret = hc_add_endpoint(instance, hub_address, 0, USB_SPEED_FULL,
-	    USB_TRANSFER_CONTROL, USB_DIRECTION_BOTH, 64, 0, 0);
-	CHECK_RET_RELEASE(ret,
-	    "Failed to add OHCI root hub endpoint 0: %s.\n", str_error(ret));
+	int ret = usb_endpoint_manager_add_ep(
+	    &instance->generic.ep_manager, hub_address, 0, USB_DIRECTION_BOTH,
+	    USB_TRANSFER_CONTROL, USB_SPEED_FULL, 64, 0);
+	CHECK_RET_UNREG_RETURN(ret,
+	    "Failed to register root hub control endpoint: %s.\n",
+	    str_error(ret));
 
 	ret = ddf_fun_add_match_id(hub_fun, "usb&class=hub", 100);
-	CHECK_RET_RELEASE(ret,
+	CHECK_RET_UNREG_RETURN(ret,
 	    "Failed to add root hub match-id: %s.\n", str_error(ret));
 
 	ret = ddf_fun_bind(hub_fun);
-	CHECK_RET_RELEASE(ret,
+	CHECK_RET_UNREG_RETURN(ret,
 	    "Failed to bind root hub function: %s.\n", str_error(ret));
 
@@ -187,10 +191,12 @@
 
 	list_initialize(&instance->pending_batches);
-	usb_device_keeper_init(&instance->manager);
-
-	ret = usb_endpoint_manager_init(&instance->ep_manager,
-	    BANDWIDTH_AVAILABLE_USB11);
-	CHECK_RET_RETURN(ret, "Failed to initialize endpoint manager: %s.\n",
+
+	ret = hcd_init(&instance->generic, BANDWIDTH_AVAILABLE_USB11,
+	    bandwidth_count_usb11);
+	CHECK_RET_RETURN(ret, "Failed to initialize generic driver: %s.\n",
 	    str_error(ret));
+	instance->generic.private_data = instance;
+	instance->generic.schedule = hc_schedule;
+	instance->generic.ep_add_hook = ohci_endpoint_init;
 
 	ret = hc_init_memory(instance);
@@ -215,47 +221,13 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Create and register endpoint structures.
- *
- * @param[in] instance OHCI driver structure.
- * @param[in] address USB address of the device.
- * @param[in] endpoint USB endpoint number.
- * @param[in] speed Communication speeed of the device.
- * @param[in] type Endpoint's transfer type.
- * @param[in] direction Endpoint's direction.
- * @param[in] mps Maximum packet size the endpoint accepts.
- * @param[in] size Maximum allowed buffer size.
- * @param[in] interval Time between transfers(interrupt transfers only).
- * @return Error code
- */
-int hc_add_endpoint(
-    hc_t *instance, usb_address_t address, usb_endpoint_t endpoint,
-    usb_speed_t speed, usb_transfer_type_t type, usb_direction_t direction,
-    size_t mps, size_t size, unsigned interval)
-{
-	endpoint_t *ep =
-	    endpoint_get(address, endpoint, direction, type, speed, mps);
-	if (ep == NULL)
-		return ENOMEM;
-
-	hcd_endpoint_t *hcd_ep = hcd_endpoint_assign(ep);
-	if (hcd_ep == NULL) {
-		endpoint_destroy(ep);
-		return ENOMEM;
-	}
-
-	int ret =
-	    usb_endpoint_manager_register_ep(&instance->ep_manager, ep, size);
-	if (ret != EOK) {
-		hcd_endpoint_clear(ep);
-		endpoint_destroy(ep);
-		return ret;
-	}
-
-	/* Enqueue hcd_ep */
+void hc_enqueue_endpoint(hc_t *instance, endpoint_t *ep)
+{
+	endpoint_list_t *list = &instance->lists[ep->transfer_type];
+	ohci_endpoint_t *ohci_ep = ohci_endpoint_get(ep);
+	/* Enqueue ep */
 	switch (ep->transfer_type) {
 	case USB_TRANSFER_CONTROL:
 		instance->registers->control &= ~C_CLE;
-		endpoint_list_add_ep(
-		    &instance->lists[ep->transfer_type], hcd_ep);
+		endpoint_list_add_ep(list, ohci_ep);
 		instance->registers->control_current = 0;
 		instance->registers->control |= C_CLE;
@@ -263,6 +235,5 @@
 	case USB_TRANSFER_BULK:
 		instance->registers->control &= ~C_BLE;
-		endpoint_list_add_ep(
-		    &instance->lists[ep->transfer_type], hcd_ep);
+		endpoint_list_add_ep(list, ohci_ep);
 		instance->registers->control |= C_BLE;
 		break;
@@ -270,89 +241,36 @@
 	case USB_TRANSFER_INTERRUPT:
 		instance->registers->control &= (~C_PLE & ~C_IE);
-		endpoint_list_add_ep(
-		    &instance->lists[ep->transfer_type], hcd_ep);
+		endpoint_list_add_ep(list, ohci_ep);
 		instance->registers->control |= C_PLE | C_IE;
 		break;
 	}
-
-	return EOK;
-}
-/*----------------------------------------------------------------------------*/
-/** Dequeue and delete endpoint structures
- *
- * @param[in] instance OHCI hc driver structure.
- * @param[in] address USB address of the device.
- * @param[in] endpoint USB endpoint number.
- * @param[in] direction Direction of the endpoint.
- * @return Error code
- */
-int hc_remove_endpoint(hc_t *instance, usb_address_t address,
-    usb_endpoint_t endpoint, usb_direction_t direction)
-{
-	assert(instance);
-	fibril_mutex_lock(&instance->guard);
-	endpoint_t *ep = usb_endpoint_manager_get_ep(&instance->ep_manager,
-	    address, endpoint, direction, NULL);
-	if (ep == NULL) {
-		usb_log_error("Endpoint unregister failed: No such EP.\n");
-		fibril_mutex_unlock(&instance->guard);
-		return ENOENT;
-	}
-
-	hcd_endpoint_t *hcd_ep = hcd_endpoint_get(ep);
-	if (hcd_ep) {
-		/* Dequeue hcd_ep */
-		switch (ep->transfer_type) {
-		case USB_TRANSFER_CONTROL:
-			instance->registers->control &= ~C_CLE;
-			endpoint_list_remove_ep(
-			    &instance->lists[ep->transfer_type], hcd_ep);
-			instance->registers->control_current = 0;
-			instance->registers->control |= C_CLE;
-			break;
-		case USB_TRANSFER_BULK:
-			instance->registers->control &= ~C_BLE;
-			endpoint_list_remove_ep(
-			    &instance->lists[ep->transfer_type], hcd_ep);
-			instance->registers->control |= C_BLE;
-			break;
-		case USB_TRANSFER_ISOCHRONOUS:
-		case USB_TRANSFER_INTERRUPT:
-			instance->registers->control &= (~C_PLE & ~C_IE);
-			endpoint_list_remove_ep(
-			    &instance->lists[ep->transfer_type], hcd_ep);
-			instance->registers->control |= C_PLE | C_IE;
-			break;
-		default:
-			break;
-		}
-		hcd_endpoint_clear(ep);
-	} else {
-		usb_log_warning("Endpoint without hcd equivalent structure.\n");
-	}
-	int ret = usb_endpoint_manager_unregister_ep(&instance->ep_manager,
-	    address, endpoint, direction);
-	fibril_mutex_unlock(&instance->guard);
-	return ret;
-}
-/*----------------------------------------------------------------------------*/
-/** Get access to endpoint structures
- *
- * @param[in] instance OHCI hc driver structure.
- * @param[in] address USB address of the device.
- * @param[in] endpoint USB endpoint number.
- * @param[in] direction Direction of the endpoint.
- * @param[out] bw Reserved bandwidth.
- * @return Error code
- */
-endpoint_t * hc_get_endpoint(hc_t *instance, usb_address_t address,
-    usb_endpoint_t endpoint, usb_direction_t direction, size_t *bw)
-{
-	assert(instance);
-	fibril_mutex_lock(&instance->guard);
-	endpoint_t *ep = usb_endpoint_manager_get_ep(&instance->ep_manager,
-	    address, endpoint, direction, bw);
-	fibril_mutex_unlock(&instance->guard);
-	return ep;
+}
+/*----------------------------------------------------------------------------*/
+void hc_dequeue_endpoint(hc_t *instance, endpoint_t *ep)
+{
+	/* Dequeue ep */
+	endpoint_list_t *list = &instance->lists[ep->transfer_type];
+	ohci_endpoint_t *ohci_ep = ohci_endpoint_get(ep);
+	switch (ep->transfer_type) {
+	case USB_TRANSFER_CONTROL:
+		instance->registers->control &= ~C_CLE;
+		endpoint_list_remove_ep(list, ohci_ep);
+		instance->registers->control_current = 0;
+		instance->registers->control |= C_CLE;
+		break;
+	case USB_TRANSFER_BULK:
+		instance->registers->control &= ~C_BLE;
+		endpoint_list_remove_ep(list, ohci_ep);
+		instance->registers->control |= C_BLE;
+		break;
+	case USB_TRANSFER_ISOCHRONOUS:
+	case USB_TRANSFER_INTERRUPT:
+		instance->registers->control &= (~C_PLE & ~C_IE);
+		endpoint_list_remove_ep(list, ohci_ep);
+		instance->registers->control |= C_PLE | C_IE;
+		break;
+	default:
+		break;
+	}
 }
 /*----------------------------------------------------------------------------*/
@@ -363,9 +281,9 @@
  * @return Error code.
  */
-int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch)
-{
-	assert(instance);
-	assert(batch);
-	assert(batch->ep);
+int hc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
+{
+	assert(hcd);
+	hc_t *instance = hcd->private_data;
+	assert(instance);
 
 	/* Check for root hub communication */
@@ -374,8 +292,11 @@
 		return EOK;
 	}
+	ohci_transfer_batch_t *ohci_batch = ohci_transfer_batch_get(batch);
+	if (!ohci_batch)
+		return ENOMEM;
 
 	fibril_mutex_lock(&instance->guard);
-	list_append(&batch->link, &instance->pending_batches);
-	batch_commit(batch);
+	list_append(&ohci_batch->link, &instance->pending_batches);
+	ohci_transfer_batch_commit(ohci_batch);
 
 	/* Control and bulk schedules need a kick to start working */
@@ -417,13 +338,13 @@
 		    instance->registers->periodic_current);
 
-		link_t *current = instance->pending_batches.head.next;
-		while (current != &instance->pending_batches.head) {
+		link_t *current = list_first(&instance->pending_batches);
+		while (current && current != &instance->pending_batches.head) {
 			link_t *next = current->next;
-			usb_transfer_batch_t *batch =
-			    usb_transfer_batch_from_link(current);
-
-			if (batch_is_complete(batch)) {
+			ohci_transfer_batch_t *batch =
+			    ohci_transfer_batch_from_link(current);
+
+			if (ohci_transfer_batch_is_complete(batch)) {
 				list_remove(current);
-				usb_transfer_batch_finish(batch);
+				ohci_transfer_batch_finish_dispose(batch);
 			}
 
@@ -434,4 +355,5 @@
 
 	if (status & I_UE) {
+		usb_log_fatal("Error like no other!\n");
 		hc_start(instance);
 	}
